// Assembler.h: Schnittstelle fr die Klasse Assembler.
//
//////////////////////////////////////////////////////////////////////

/*
#if !defined(AFX_ASSEMBLER_H__021ADA61_0BFE_11D4_84FC_00C0DFC1D30C__INCLUDED_)
#define AFX_ASSEMBLER_H__021ADA61_0BFE_11D4_84FC_00C0DFC1D30C__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
*/

typedef bool	BOOL;

//#if !defined(STR_HEADER)
#include "str.h"
//#endif
#include <fstream>
//#include <iostream>


#define		MAP_LIST_SIZE			200

typedef long					Long;
typedef char					Flags;
typedef char					Bool;
typedef Long					ValueType;
typedef unsigned short		IndexType;
typedef char					CategoryType;
typedef char					OutType;

#define		MAX_LABEL_LENGTH	60

class Assembler  
{
	struct Map;

	struct Label
	{
		Label*				nextlist;
		Flags					type;
		Bool					defined;
		IndexType			index;
		ValueType			value;
		short					namelength;
		char 					name[MAX_LABEL_LENGTH+1];
		unsigned short		block_number;
		Map*				map;
		Long				linenumber;
	};

	struct Map
	{
		OutType*					base;
		Long					position;
		Long					length;
		Label*				labellist;

		Map*						macro_caller_map;   //= also next_map for include-files
		OutType*					macro_marker_base[9];
		int						macro_marker_position[9];
		int						macro_marker_length[9];
		int						number_of_macro_markers;

	//	OutType*				out;

	//	Label*				label;
	//	ValueType			number;

		char*	filename;
		bool	macro_call;
		Long	start_linenumber;
		//int		filename_length;
		//Map*	previous_map;
		//Map*	next_map;
	};

public:
	Assembler();
	virtual ~Assembler();

	int Assemble(char* sourcefile);

protected:

	Flags AssembleMap(Map* map,BOOL first_pass);
	bool DefineLabel(Label*& definition_label);
	Flags GetDecimalNumber(Map* map,ValueType& number);
	Flags GetHexNumber(Map* map,ValueType& number);
	Flags GetBinaryNumber(Map* map,ValueType& number);
	void GetLabel(Map* map,Label*& label,BOOL enter_new_label);
	Flags GetNextLine(Map* map);
	Flags GetString(Map* map,Long& stringlength);
	Flags GetThisLine(Map* map);
	Map* OpenSourceFile(char* filename);
	bool PopMap(Map* map);
	void PrintLabels();
	bool PushMap(Map* map);
	void DeleteLabelTable();
	char Make_C64_ASCII(char);

	Map		map_list[MAP_LIST_SIZE];
	int		map_list_counter;

	unsigned short mother_block_list[0x10000];
	unsigned short block_level_list[0x10000];
	unsigned short block_counter;
	unsigned short block_level;
	unsigned short current_block;
	OutType	out[0x10000];

	Flags		error;
	Flags		warning;
	int		error_counter;
	int		warning_counter;

	str path;
	std::ofstream term;


//*************************************************
//**                                             **
//**                 TABLES                      **
//**                                             **
//*************************************************

	static char* ErrorTable[];
	static char* WarningTable[];
	static char* endif_string;
	static char* endmacro_string;

static Label k128;
static Label k127;
static Label k126;
static Label k125;
static Label k124;
static Label k123;
static Label k122;
static Label k121;
static Label k120;
static Label k119;
static Label k118;
static Label k117;
static Label k116;
static Label k115;
static Label k114;
static Label k113;
static Label k112;
static Label k111;
static Label k110;
static Label k109;
static Label k108;
static Label k107;
static Label k106;
static Label k105;
static Label k104;
static Label k103;
static Label k102;
static Label k101;

static Label k98;
static Label k99;
static Label InstructionLabelList;

static Label EndTable;
static Label LabelList_2;
static Label k0;
static Label k1;
static Label k2;
static Label k3;
static Label k4;
static Label k5;
static Label k6;
static Label k7;
static Label k8;
static Label k9;

static Label k10;
static Label k11;
static Label k12;
static Label k13;
static Label k14;
static Label k15;
static Label k16;
static Label k17;
static Label k18;
static Label k19;

static Label k20;
static Label k21;
static Label k22;
static Label k23;
static Label k24;
static Label k25;
static Label k26;
static Label k27;
static Label k28;
static Label k29;

static Label k30;
static Label k31;
static Label k32;
static Label k33;
static Label k34;
static Label k35;
static Label k36;
static Label k37;
static Label k38;
static Label k39;

static Label k40;
static Label k41;
static Label k42;
static Label k43;
static Label k44;
static Label k45;
static Label k46;
static Label k47;
static Label k48;
static Label k49;

static Label k50;
static Label k51;
static Label k52;
static Label k53;
static Label k54;
static Label LabelList;

static Bool	AddressmodeOperandSize[];
static CategoryType	CategoryTable[];
static Flags Instr_AssembleStatus[];
static Bool Instr_OperandIsLong[];
static Bool Instr_SeveralOperands[];
static Bool Instr_Declaration[];
static Flags Instr_DeclareAs[];


};

//#endif // !defined(AFX_ASSEMBLER_H__021ADA61_0BFE_11D4_84FC_00C0DFC1D30C__INCLUDED_)
